# TODO:
#   clean up code
#   poll for changes


BROKEN    = True
DISABLED= True

# Import the required system modules.
try:
    import bonobo
    import CORBA

    BROKEN    = False
    DISABLED= False
except ImportError, error:
    print("*** ERROR ***")
    print("Unable to import required modules: %s" % error)
    print("This package requires:")
    print("  gnome-python >= 2.6.0")
    print("  pyorbit >= 2.0.0")
    print("*** ERROR ***")
    print("")
except Exception, error:
    print("*** ERROR ***")
    print("Unknown error: %s" % error)
    print("*** ERROR ***")
#end try

# Import Rhythmlet modules.
from    RLInput            import RLInput


# Set constant values.
EVENTSOURCE_IID        = "OAFIID:Bonobo_Activation_EventSource"
EVENTSOURCE_IDL        = "IDL:Bonobo/EventSource:1.0"
EVENT_REGISTER        = "Bonobo/ObjectDirectory:activation:register"
EVENT_UNREGISTER    = "Bonobo/ObjectDirectory:activation:unregister"
RHYTHMBOX_IID        = "OAFIID:GNOME_Rhythmbox"
RHYTHMBOX_IDL        = "IDL:GNOME/Rhythmbox:1.0"
RB_CHANGE_PLAYING    = "Bonobo/Property:change:playing"
RB_CHANGE_REPEAT    = "Bonobo/Property:change:repeat"
RB_CHANGE_SHUFFLE    = "Bonobo/Property:change:shuffle"
RB_CHANGE_SONG        = "Bonobo/Property:change:song"
BOOLEAN_IDL            = "IDL:omg.org/CORBA/boolean:1.0"

#class _Rhythmbox_Bonobo(RLInput):
class Rhythmbox_Bonobo(RLInput):
    """
    Rhythmbox (Bonobo) class for Rhythmlet
    """


    def __init__(self, *args):
        """
        Initialise Rhythmbox class.
        """

        # Initialise base class.
        RLInput.__init__(self)

        # Initialise variables.
        self._rhythmbox = None
        self._rbProps    = None
        self._rbSong    = None
        self._running    = False
    #end __init__()


    def disable(self):
        DISABLED = True
    #end disable()

    def enable(self):
        # Return immediately if we're disabled
        if (BROKEN):
            DISABLED = True

            return(False)
        #end if

        DISABLED = False

        # Set Bonobo listeners (register/unregister):
        # (appropriated from tune <http://tune.jabberstudio.org/>)
        event_source = bonobo.get_object(EVENTSOURCE_IID, EVENTSOURCE_IDL)
        bonobo.event_source_client_add_listener(event_source, self._bonobo_register, EVENT_REGISTER)
        bonobo.event_source_client_add_listener(event_source, self._bonobo_register, EVENT_UNREGISTER)

        # Get Rhythmbox's running state & update immediately.
        self._bonobo_register()

        return(True)
    #end enable()


    def _bonobo_register(self, listener=None, event=None, value=None, error=None):
        """
        Update information when Rhythmbox is launched/closed.
        """

        #self.debug("Recieved register/unregister event")

        try:
            if ((bonobo.activation.query("(repo_ids.has('%s')) AND (_active == TRUE)" % RHYTHMBOX_IDL))):
                self._rhythmbox = bonobo.activation.activate_from_id(RHYTHMBOX_IID, 0, None)
                self._rbProps = self._rhythmbox.getPlayerProperties()

                if (not self._running):
                    self.debug("Rhythmbox is running.")
                    self._running = True

                    self.refresh()

                    # Add Bonobo listeners.
                    #  NOTE: shuffle/repeat/play-order don't notify.
                    self.debug("Adding Bonobo listeners...")
                    bonobo.event_source_client_add_listener(self._rbProps, self._bonobo_state_change, RB_CHANGE_PLAYING)
                    bonobo.event_source_client_add_listener(self._rbProps, self._bonobo_state_change, RB_CHANGE_REPEAT)
                    bonobo.event_source_client_add_listener(self._rbProps, self._bonobo_state_change, RB_CHANGE_SHUFFLE)
                    bonobo.event_source_client_add_listener(self._rbProps, self._bonobo_song_change, RB_CHANGE_SONG)
                #end if
            else:
                if (self._running):
                    self.debug("Rhythmbox is (probably) not running.")

                    self._running = False
                    self._rhythmbox = None
                    self._rbProps = None
                    self._rbSong = None

                    self._bonobo_song_change()
                #end if
            #end if
        except CORBA.COMM_FAILURE:
            self._running = False
        except Exception, error:
            self.handle_exception(error)
        #end try

        # Run callbacks
        self.active_change()
        #self._bonobo_state_change()
        #self._bonobo_song_change()
    #end _bonobo_register()

    def _bonobo_state_change(self, listener=None, event=None, value=None, error=None):
        self.state_change()
    #end _bonobo_state_change()

    def _bonobo_song_change(self, listener=None, event=None, value=None, error=None):
        self.refresh()
        self.song_change()
    #end _bonobo_song_change()


    def refresh(self):
        """
        Update information from Rhythmbox. Return True if successful, False otherwise
        """

        # Return immediately if we're disabled
        if (DISABLED):
            return(False)
        #end if

        try:
            if (self.is_active()):
                self._rbSong = self._rbProps.getValue("song").value()

                return(True)
            else:
                self._rbSong = None
            #end if
        except CORBA.COMM_FAILURE:
            self._running = False
        except AttributeError:
            self._running = False
        except Exception, error:
            self.handle_exception(error)
        #end try

        return(False)
    #end refresh()


    def is_active(self):
        """
        Return True if Rhythmbox is active, False otherwise.
        """

        # Return immediately if we're disabled
        if (DISABLED):
            return(False)
        #end if

        if (not self._running):
            return(False)
        #end if

        return(True)
    #end is_active()


    def has_song_info(self):
        """
        Return True if Rhythmbox has SongInfo struct available, False otherwise.
        """

        try:
            if (self._rbSong.artist):
                return(True)
            #end if
        except:
            pass
        #end try

        return(False)
    #end has_song_info()


    def __getitem__(self, key):
        """
        Return data from Rhythmbox.
        """

        ret_val = "None"

        if ((not DISABLED) and self.is_active()):
            try:
                if (self.has_song_info()):
                    if (key == "album"):            ret_val = str(self._rbSong.album)
                    if (key == "artist"):            ret_val = str(self._rbSong.artist)
                    if (key == "bitrate"):            ret_val = int(self._rbSong.bitrate)
                    if (key == "duration"):            ret_val = int(self._rbSong.duration)
                    if (key == "file_size"):        ret_val = int(self._rbSong.filesize)
                    if (key == "genre"):            ret_val = str(self._rbSong.genre)
                    if (key == "last_played"):        ret_val = int(self._rbSong.last_played)
                    if (key == "play_count"):        ret_val = int(self._rbSong.play_count)
                    if (key == "rating"):            ret_val = int(self._rbSong.rating)
                    if (key == "title"):            ret_val = str(self._rbSong.title)
                    if (key == "track_number"):        ret_val = int(self._rbSong.track_number)
                    if (key == "uri"):                ret_val = str(self._rbSong.path)
                #end if

                if (key == "elapsed_time"):            ret_val = int(self._rhythmbox.getPlayingTime())
                if (key == "playing"):                ret_val = bool(self._rbProps.getValue("playing").value())
                if (key == "repeat"):                ret_val = bool(self._rbProps.getValue("repeat").value())
                if (key == "shuffle"):                ret_val = bool(self._rbProps.getValue("shuffle").value())
            except CORBA.COMM_FAILURE:
                self._running = False
            except Exception, error:
                self.handle_exception(error)
            #end try

        if (ret_val == "None"):
            # Return appropriate types depending on key.
            if (key == "album"):            return("")
            if (key == "artist"):            return("")
            if (key == "bitrate"):            return(0)
            if (key == "duration"):            return(0)
            if (key == "elapsed_time"):        return(0)
            if (key == "file_size"):        return(0)
            if (key == "genre"):            return("")
            if (key == "last_played"):        return(0)
            if (key == "play_count"):        return(0)
            if (key == "playing"):            return(False)
            if (key == "rating"):            return(0)
            if (key == "repeat"):            return(False)
            if (key == "shuffle"):            return(False)
            if (key == "title"):            return("")
            if (key == "track_number"):        return(0)
            if (key == "uri"):                return("")
            return("")
        else:
            return(ret_val)
        #end if
    #end __getitem__()


    def __setitem__(self, key, value):
        """
        Set Rhythmbox data.
        """

        # Return immediately if we're disabled
        if (DISABLED):
            return(None)
        #end if

        # Return immediately if Rhythmbox is not running.
        if (not self.is_active()):
            return(None)
        #end if

        try:
            if (self.has_song_info()):
                if (key == "elapsed_time"):
                    self._rhythmbox.setPlayingTime(value)

                    # Run callbacks
                    self._bonobo_song_change()
                if (key == "rating"):
                    if (value > 5):    value = 5
                    if (value < 0):    value = 0

                    self._rhythmbox.setRating(value)

                    # Run callbacks
                    self._bonobo_song_change()
                #end if
            #end if

            if (key == "playing"):
                self._rhythmbox.playPause()

                # No need to run callbacks here; Bonobo will notify us.
            if (key == "repeat"):
                new_val = CORBA.Any(CORBA.TypeCode(BOOLEAN_IDL), CORBA.FALSE)
                if (value):
                    new_val = CORBA.Any(CORBA.TypeCode(BOOLEAN_IDL), CORBA.TRUE)
                #end if

                self._rbProps.setValue("repeat", new_val)

                # Run callbacks
                self._bonobo_state_change()
            if (key == "shuffle"):
                new_val = CORBA.Any(CORBA.TypeCode(BOOLEAN_IDL), CORBA.FALSE)
                if (value):
                    new_val = CORBA.Any(CORBA.TypeCode(BOOLEAN_IDL), CORBA.TRUE)
                #end if

                self._rbProps.setValue("shuffle", new_val)

                # Run callbacks
                self._bonobo_state_change()
            #end if
        except CORBA.COMM_FAILURE:
            self._running = False
        except Exception, error:
            self.handle_exception(error)
        #end try
    #end __setitem__()


    def run_command(self, command, args=None):
        """
        Run specified command with optional args.
        """

        # Return immediately if we're disabled
        if (DISABLED):
            return(None)
        #end if

        # Return immediately if Rhythmbox is not running.
        if (not self.is_active()):
            return(None)
        #end if

        try:
            if (command == "NEXT"):            self._rhythmbox.next()
            if (command == "PAUSE"):        self._rhythmbox.pause()
            if (command == "PLAY"):            self._rhythmbox.play()
            if (command == "PLAY_PAUSE"):    self._rhythmbox.playPause()
            if (command == "PLAY_URI"):        self._rhythmbox.handleFile(args)
            if (command == "PREVIOUS"):        self._rhythmbox.previous()
        except Exception, error:
            self.handle_exception(error)
        #end try
    #end run_command()
#end class
